"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var HyperMediaConfig_1 = require("./types/HyperMediaConfig");
var PlayerManager = /** @class */ (function (_super) {
    __extends(PlayerManager, _super);
    function PlayerManager(pluginClasses, config) {
        var _this = _super.call(this) || this;
        _this.config = __assign({}, HyperMediaConfig_1.defaultHyperMediaConfig, config);
        _this.plugins = [];
        pluginClasses.forEach(function (PluginClass) {
            var obj = new PluginClass(_this, config);
            if (_this.validatePlugin(obj)) {
                _this.plugins.push(obj);
            }
            else {
                console.error("Media plugin " + PluginClass.name + " failed validation. It may be missing some required methods.");
            }
        });
        console.log("Loaded " + _this.plugins.length + " media plugins.");
        var maybeDefault = _this.plugins.filter(function (x) { return x.playerName() === _this.config.default; }).pop();
        if (!config.default || !maybeDefault)
            _this.setActivePlugin(_this.plugins[0]);
        else
            _this.setActivePlugin(maybeDefault);
        return _this;
    }
    PlayerManager.prototype.setActivePlugin = function (newPlugin) {
        if (this.currentPlugin) {
            this.currentPlugin.deactivate();
            this.currentPlugin.removeAllListeners();
        }
        this.currentPlugin = newPlugin;
        if (newPlugin) {
            newPlugin.activate();
        }
        this.emit('newPlugin', newPlugin);
    };
    PlayerManager.prototype.validatePlugin = function (pluginObject) {
        var requiredFunctions = [
            'playerName',
            'iconUrl',
            'activate',
            'deactivate'
        ];
        for (var i = 0; i < requiredFunctions.length; i++) {
            if (!((pluginObject[requiredFunctions[i]]) instanceof Function)) {
                return false;
            }
        }
        return true;
    };
    return PlayerManager;
}(events_1.EventEmitter));
exports.PlayerManager = PlayerManager;
