/// <reference types="react" />
import * as ExternReact from 'react';
import { PlayerManager } from '../PlayerManager';
import { MediaPlugin } from '../types/MediaPlugin';
import { Track } from '../types/Track';
interface BackgroundProps {
    playerManager: PlayerManager;
}
interface BackgroundState {
    plugin: MediaPlugin;
    playlist: Track[];
}
declare function BackgroundFactory(React: typeof ExternReact): {
    new (props: any): {
        componentDidMount(): void;
        render(): JSX.Element;
        setState<K extends "plugin" | "playlist">(state: BackgroundState | ((prevState: Readonly<BackgroundState>, props: BackgroundProps) => BackgroundState | Pick<BackgroundState, K>) | Pick<BackgroundState, K>, callback?: () => void): void;
        forceUpdate(callBack?: () => void): void;
        props: Readonly<{
            children?: ExternReact.ReactNode;
        }> & Readonly<BackgroundProps>;
        state: Readonly<BackgroundState>;
        context: any;
        refs: {
            [key: string]: ExternReact.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<BackgroundProps>, nextState: Readonly<BackgroundState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: ExternReact.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<BackgroundProps>, prevState: Readonly<BackgroundState>): any;
        componentDidUpdate?(prevProps: Readonly<BackgroundProps>, prevState: Readonly<BackgroundState>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<BackgroundProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<BackgroundProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<BackgroundProps>, nextState: Readonly<BackgroundState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<BackgroundProps>, nextState: Readonly<BackgroundState>, nextContext: any): void;
    };
};
export { BackgroundFactory, BackgroundProps, BackgroundState };
