"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var os = require("os");
function BackgroundFactory(React) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1(props) {
            var _this = _super.call(this, props) || this;
            var playerManager = _this.props.playerManager;
            _this.state = {
                plugin: playerManager.currentPlugin,
                playlist: []
            };
            playerManager.currentPlugin.on('playlist', function (playlist) { return _this.setState({ playlist: playlist }); });
            return _this;
        }
        class_1.prototype.componentDidMount = function () {
            var _this = this;
            var playerManager = this.props.playerManager;
            playerManager.on('newPlugin', function (newPlugin) {
                _this.setState({ plugin: newPlugin, playlist: [] });
                newPlugin.on('playlist', function (playlist) {
                    _this.setState({ playlist: playlist });
                });
            });
        };
        class_1.prototype.render = function () {
            var playlist = this.state.playlist;
            return React.createElement("div", { style: backgroundStyle }, playlist.map(function (x) { return React.createElement("div", null, x.isPlaying ? React.createElement("b", null, x.name) : x.name); }));
        };
        return class_1;
    }(React.Component));
}
exports.BackgroundFactory = BackgroundFactory;
var backgroundStyle = {
    position: 'absolute',
    top: os.platform() === 'darwin' ? 0 : 35,
    right: 10,
    marginBottom: 30,
    opacity: 0.5,
    textAlign: 'right',
    fontSize: 12,
    overflow: 'none'
};
