/// <reference types="react" />
import * as ExternReact from 'react';
import { PlayerManager } from '../PlayerManager';
import { HyperMediaConfig } from '../types/HyperMediaConfig';
import { MediaPlugin } from '../types/MediaPlugin';
import { Status } from '../types/Status';
interface MediaBarProps {
    playerManager: PlayerManager;
}
interface MediaBarState {
    plugin: MediaPlugin;
    status: Status;
}
declare function MediaBarFactory(React: typeof ExternReact): {
    new (props: MediaBarProps): {
        newLoad: boolean;
        hyperMedia: HyperMediaConfig;
        componentDidMount(): void;
        render(): JSX.Element;
        handleActionResult(result: any): void;
        cyclePlugin(): void;
        setState<K extends "plugin" | "status">(state: MediaBarState | ((prevState: Readonly<MediaBarState>, props: MediaBarProps) => MediaBarState | Pick<MediaBarState, K>) | Pick<MediaBarState, K>, callback?: () => void): void;
        forceUpdate(callBack?: () => void): void;
        props: Readonly<{
            children?: ExternReact.ReactNode;
        }> & Readonly<MediaBarProps>;
        state: Readonly<MediaBarState>;
        context: any;
        refs: {
            [key: string]: ExternReact.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<MediaBarProps>, nextState: Readonly<MediaBarState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: ExternReact.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<MediaBarProps>, prevState: Readonly<MediaBarState>): any;
        componentDidUpdate?(prevProps: Readonly<MediaBarProps>, prevState: Readonly<MediaBarState>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<MediaBarProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<MediaBarProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<MediaBarProps>, nextState: Readonly<MediaBarState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<MediaBarProps>, nextState: Readonly<MediaBarState>, nextContext: any): void;
    };
};
export { MediaBarFactory, MediaBarProps, MediaBarState };
