"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var hyper_plugin_extend_1 = require("hyper-plugin-extend");
var PlayerManager_1 = require("./PlayerManager");
exports.PlayerManager = PlayerManager_1.PlayerManager;
var State_1 = require("./types/State");
exports.State = State_1.State;
var Footer_1 = require("./components/Footer");
var parentPluginName = 'hyper-media-control';
var onRendererWindow = hyper_plugin_extend_1.registerParentPlugin(parentPluginName);
exports.onRendererWindow = onRendererWindow;
function decorateHyper(Hyper, _a) {
    var React = _a.React;
    var Footer = Footer_1.FooterFactory(React);
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1(props) {
            var _this = _super.call(this, props) || this;
            _this.state = {};
            _this.playerManager = new PlayerManager_1.PlayerManager(hyper_plugin_extend_1.getSubPlugins(parentPluginName), _this.props.hyperMedia);
            return _this;
        }
        class_1.prototype.render = function () {
            var existingInnerChildren = this.props.customInnerChildren;
            var customInnerChildren = existingInnerChildren ? existingInnerChildren instanceof Array ? existingInnerChildren : [existingInnerChildren] : [];
            if (this.playerManager.plugins.length > 0) {
                customInnerChildren = [].concat(customInnerChildren, React.createElement(Footer, { playerManager: this.playerManager }));
            }
            return React.createElement(Hyper, __assign({ customInnerChildren: customInnerChildren }, this.props));
        };
        return class_1;
    }(React.PureComponent));
}
exports.decorateHyper = decorateHyper;
function decorateConfig(config) {
    return __assign({}, config, { css: "\n      " + (config.css || '') + "\n\n        .terms_terms {\n          margin-bottom: 30px;\n        }\n\n        .hyper-media.hoverable:hover,\n        .hyper-media .hoverable:hover {\n          opacity: 1 !important\n        }\n    " });
}
exports.decorateConfig = decorateConfig;
function reduceUI(state, _a) {
    var type = _a.type, config = _a.config;
    switch (type) {
        case 'CONFIG_LOAD':
        case 'CONFIG_RELOAD':
            return state.set('hyperMedia', config.hyperMedia);
    }
    return state;
}
exports.reduceUI = reduceUI;
function mapHyperState(_a, map) {
    var hyperMedia = _a.ui.hyperMedia;
    return __assign({}, map, { hyperMedia: __assign({}, hyperMedia) });
}
exports.mapHyperState = mapHyperState;
function decorateMenu(menu) {
    return menu.map(function (item) {
        if (item.label !== 'Plugins')
            return item;
        var newItem = __assign({}, item);
        newItem.submenu = newItem.submenu.concat({
            label: 'Hyper Media Control',
            type: 'submenu',
            submenu: [
                {
                    label: 'Previous Track',
                    click: function (clickedItem, focusedWindow) {
                        if (focusedWindow) {
                            focusedWindow.rpc.emit('hyper-media-control:previousTrack', { focusedWindow: focusedWindow });
                        }
                    }
                },
                {
                    label: 'Play/Pause',
                    accelerator: "CmdOrCtrl+Alt+Space",
                    click: function (clickedItem, focusedWindow) {
                        if (focusedWindow) {
                            focusedWindow.rpc.emit('hyper-media-control:playPause', { focusedWindow: focusedWindow });
                        }
                    }
                },
                {
                    label: 'Next Track',
                    click: function (clickedItem, focusedWindow) {
                        if (focusedWindow) {
                            focusedWindow.rpc.emit('hyper-media-control:nextTrack', { focusedWindow: focusedWindow });
                        }
                    }
                },
                {
                    label: 'Next Media Player',
                    accelerator: "CmdOrCtrl+Shift+Space",
                    click: function (clickedItem, focusedWindow) {
                        if (focusedWindow) {
                            focusedWindow.rpc.emit('hyper-media-control:nextPlayer', { focusedWindow: focusedWindow });
                        }
                    }
                }
            ]
        });
        return newItem;
    });
}
exports.decorateMenu = decorateMenu;
